<?php

namespace TecFood\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\Environment;
use TecFood\Services\User as UserService;

class User {

    protected $dataSourceName = "operador";
    protected $environment;
    protected $userService;

    public function __construct(Environment $environment, UserService $userService) {
        $this->environment = $environment;
        $this->userService = $userService;
    }

    public function changeUserUnit(DTO\Request $request, DTO\Response $response) {
        try {
            $userRow = $this->getBuildedUserRow($request->getRow());
            $this->userService->changeUserUnit($userRow);
            $response->addDataSet(new DataSet($this->dataSourceName, $userRow));
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    private function getBuildedUserRow($row) {
        $userRow = array(
            "NRORG" => $row['nrorg'],
            "CDFILIAL" => $row['cdfilial'],
            "CDOPERADOR" => $this->environment->getCdoperador()
        );
        return $userRow;
    }
}