// FILE: ./assets/js/utilities/utilitiesNext.js
function utilitiesNext(templateManager, localStorageEngine) {
    
    this.getPromiseLogin = function(){
        return localStorageEngine.getLocalVar('loginPromise');
    };
	
	this.getUrlTecFoodNext = function(route) {
        var token = localStorage.getItem('LOGIN_TOKEN');
        var hash = localStorage.getItem('LOGIN_HASH') || '0';
        var user = getLocalVar('NEXTSESSION_ENCRYPTED');
        var languange = localStorage.getItem('LOGIN_LANGUAGE');
        var productId = window.projectId;

        return window.nextUrl + "modules/" + route + "?header=0&menu=0" +
            "&token=" + token +
            "&hash=" + hash +
            "&user=" + user +
            "&languange=" + languange +
            "&productId=" + productId +
            "&isZhAngular=1";
    };
    
    var getFrameWidgetNext =  function(frame){
		return templateManager.container.getWidget(frame);
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('utilitiesNext', utilitiesNext);
});


// FILE: ./assets/js/services/Ger00000CadastramentosAutomaticoService.js
var Ger00000CadastramentosAutomaticoService = function (MessageService) {
    
    const glossary = {
        'MARCA': {
            'CDMARCA' : {
      	        'desc'     : 'Informar o código do marca.',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'NMMARCA' : {
      	        'desc'     : 'Informar o nome da marca.',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    },
      	    'IDMARCAATIVA' : {
      	        'desc'     : 'Informar o valor "A".',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        },
        'MARCA1': {
            'CDMARCA1' : {
      	        'desc'     : 'Informar o código do marca.',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 5
      	    },
      	    'NMMARCA1' : {
      	        'desc'     : 'Informar o nome da marca.',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 20
      	    },
      	    'IDMARCAATIVA1' : {
      	        'desc'     : 'Informar o valor "A".',
      	        'template' : 'field/textarea.html', 
      	        'textRows' : 1
      	    }
        }
    };

	this.getGlossary = function(tableName) {
	    return glossary[tableName];
	};
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00000CadastramentosAutomaticoService', Ger00000CadastramentosAutomaticoService);
});

// FILE: ./assets/js/services/ger00003_unidadeService.js
var UnidadeService = function (restEngine, requestDataSourceEngine) {

	this.alterarEstrutura = function (cdfilial, nrorg) {
		return restEngine.post("product#/changeUserUnit", {
			"requestType": "Row",
			"row": {
				"cdfilial": cdfilial,
				"nrorg": nrorg
			}
		});
	};

	this.updateMongoSession = function (nmfilial, cdfilial) {
		var filter = [
			{
                name: 'OTHER_SESSION_VALUES',
                value: {
                    NMFILIAL: nmfilial,
                    CDFILIAL: cdfilial
                },
                operator: '='
            }
		];
		return requestDataSourceEngine.getDataSource("lib#/lib_updateSession", filter);
	};

};

Configuration(function (ContextRegister) {
	ContextRegister.register('UnidadeService', UnidadeService);
});

// FILE: ./assets/js/services/parametrizacaoAplicativosService.js
function parametrizacaoAplicativosService(localStorageEngine, restEngine) {

	this.paramgeral = function() {

		return restEngine.post('product#/crud/paramgeral', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				}
			]
		});

	};

    this.parasupri = function(cdfilial){

        return restEngine.post('product#/crud/parasupri', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

    this.parcmpsup = function(cdfilial){

        return restEngine.post('product#/crud/parcmpsup', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

	this.paramplaneja = function() {

		return restEngine.post('product#/crud/paramplaneja', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("CDFILIAL")
				}
			]
		});

	};

	this.retornaNivelMaxProduto = function(){
        mascaraProduto = getLocalVar('CDPICTPROD');
        nivelMax = mascaraProduto.split('.').length;

        return nivelMax;
    };

    this.retornaNivelMaxPrato = function(){
        mascaraPrato = getLocalVar('CDPICTPRAT');
        nivelMax = mascaraPrato.split('.').length;

        return nivelMax;
    };

	this.paramfilial = function() {
		var nrorg = arguments[0] || localStorageEngine.getLocalVar("NRORG");
		var cdfilial = arguments[1] || localStorageEngine.getLocalVar("CDFILIAL");
		return restEngine.post('product#/crud/paramfilial', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": nrorg
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": cdfilial
				}
			]
		});

	};

	this.retornaDataProcessamento = function(cdfilial, nrorg) {

		return this.paramfilial(nrorg, cdfilial).then(function(callback) {

			var dtprocessa = callback.dataset.paramfilial[0].DTPROCESSA;

			if(dtprocessa) {
				return moment(dtprocessa,'DD/MM/YYYY HH:mm:ss').format('L');
			} else {
				return moment().format('L');
			}

		});

	};

	this.saveRow = function(row){
		return restEngine.post('product#/appconfig/save', {
			"requestType": "Row",
			"row": row
		});
	};

	this.checkMaxApps = function(){
		return restEngine.post('product#/crud/remaningApps', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				}
			]
		});
	};

	this.deleteRow = function(row){
		return restEngine.post('product#/crud/appconfig/remove', {
			"requestType": "Row",
			"row": row
		});
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('parametrizacaoAplicativosService', parametrizacaoAplicativosService);
});


// FILE: ./assets/js/services/Parametros.js
function Parametros(localStorageEngine, restEngine) {

	this.paramgeral = function() {

		return restEngine.post('product#/crud/paramgeral', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				}
			]
		});

	};

    this.parasupri = function(cdfilial){

        return restEngine.post('product#/crud/parasupri', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

    this.parcmpsup = function(cdfilial){

        return restEngine.post('product#/crud/parcmpsup', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

	this.paramplaneja = function() {

		return restEngine.post('product#/crud/paramplaneja', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("CDFILIAL")
				}
			]
		});

	};

	this.retornaNivelMaxProduto = function(){
        mascaraProduto = getLocalVar('CDPICTPROD');
        nivelMax = mascaraProduto.split('.').length;

        return nivelMax;
    };

    this.retornaNivelMaxPrato = function(){
        mascaraPrato = getLocalVar('CDPICTPRAT');
        nivelMax = mascaraPrato.split('.').length;

        return nivelMax;
    };

	this.paramfilial = function() {
		var nrorg = arguments[0] || localStorageEngine.getLocalVar("NRORG");
		var cdfilial = arguments[1] || localStorageEngine.getLocalVar("CDFILIAL");
		return restEngine.post('product#/crud/paramfilial', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": nrorg
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": cdfilial
				}
			]
		});

	};

	this.retornaDataProcessamento = function(cdfilial, nrorg) {

		return this.paramfilial(nrorg, cdfilial).then(function(callback) {

			var dtprocessa = callback.dataset.paramfilial[0].DTPROCESSA;

			if(dtprocessa) {
				return moment(dtprocessa,'DD/MM/YYYY HH:mm:ss').format('L');
			} else {
				return moment().format('L');
			}

		});

	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Parametros', Parametros);
});


// FILE: ./assets/js/controllers/Ger00000CadastramentosAutomaticoController.js
function Ger00000_Cadastramentos_Automatico_Controller(ScreenService, metaDataFactory, General, ZHPromise, templateManager, ZhFilterPreferences,restEngine, localStorageEngine, Ger00000CadastramentosAutomaticoService) {
    
    var self = this;
  	var campos = [];
  	var fields;
  	
  	var erros = [];
  	
  	var ServiceImportacao = Ger00000CadastramentosAutomaticoService;
  	
  	/*var glossary = 
  	    {
  	        
  	    //Tabela Fornecedor
  	    'IDTPIJURFORN' : {
  	        'desc'     : 'Utilizado para identificar o tipo do fornecedor.\nJ – Jurídico;\nF- Físico;\nI – Internacional;\nO – Outros;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 5
  	        
  	    },
  	    'NRINSJURFORN' : {
  	        'desc'     : 'Informar o CNPJ do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRINSESTFORN' : {
  	        'desc'     : 'Informar a inscrição estadual do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMRAZSOCFORN' : {
  	        'desc'     : 'Informar a razão social do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMFANTFORN' : {
  	        'desc'     : 'Informar o nome fantasia do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'IDENDEMISFOR' : {
  	        'desc'     : 'Informar o endereço para emissão, neste campo as informações são pré-definidas.\nP - Endereço do Fornecedor;\nC - Endereço de Cobrança;\nE - Endereço do Exterior;\nX - Endereço de Exportação;\nT - Endereço de Entrega;\nI - Endereço da Inscrição Estadual;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 6
  	        
  	    },
  	    'IDENDCFOPFOR' : {
  	        'desc'     : 'Informar o endereço para o CFOP, neste campo as informações são pré-definidas.\nP - Endereço do Fornecedor;\nC - Endereço de Cobrança;\nE - Endereço do Exterior;\nX - Endereço de Exportação;\nT - Endereço de Entrega;\nI - Endereço da Inscrição Estadual;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 7
  	        
  	    },
  	    'IDPRIPUBFORN' : {
  	        'desc'     : 'Informar se o fornecedor é público ou privado.\nV – Privado;\nB – Público;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 3
  	        
  	    },//PRINCIPAL
  	    'IDTPENDEFORN' : {
  	        'desc'     : 'Informar o valor "P" para cadastrar o endereço principal.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDPAIS' : {
  	        'desc'     : 'Informar o pais do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'SGESTADO' : {
  	        'desc'     : 'Informar o estado do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDMUNICIPIO' : {
  	        'desc'     : 'Informar o código do município do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMMUNICIPIO' : {
  	        'desc'     : 'Informar o nome do município do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSENDEFORN' : {
  	        'desc'     : 'Informar a descrição do endereço do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSCOMPENDFOR' : {
  	        'desc'     : 'Informar o descrição do complemento do endereço do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMBAIRFORN' : {
  	        'desc'     : 'Informar o nome do bairro do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRCEPFORN' : {
  	        'desc'     : 'Informar o CEP do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSEMAILFORN' : {
  	        'desc'     : 'Informar o nome do bairro do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSEMAILFORNNFE' : {
  	        'desc'     : 'Informar o email do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRCELULARFOR' : {
  	        'desc'     : 'Informar o telefone celular do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRTELRESIFOR' : {
  	        'desc'     : 'Informar o telefone fixo do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },//COBRANÇA
  	    'IDTPENDEFORNCOBR' : {
  	        'desc'     : 'Informar o valor "C" para cadastrar o endereço de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDPAISCOBR' : {
  	        'desc'     : 'Informar o pais de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'SGESTADOCOBR' : {
  	        'desc'     : 'Informar o estado (sigla) de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDMUNICIPIOCOBR' : {
  	        'desc'     : 'Informar o município de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMMUNICIPIOCOBR' : {
  	        'desc'     : 'Informar o nome do município de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSENDEFORNCOBR' : {
  	        'desc'     : 'Informar o endereço de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSCOMPENDFORCOBR' : {
  	        'desc'     : 'Informar o complemento do endereço de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMBAIRFORNCOBR' : {
  	        'desc'     : 'Informar o bairro de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRCEPFORNCOBR' : {
  	        'desc'     : 'Informar o CEP de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSEMAILFORNCOBR' : {
  	        'desc'     : 'Informar o email de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSEMAILFORNNFECOBR' : {
  	        'desc'     : 'Informar o email XML NF-e de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRCELULARFORCOBR' : {
  	        'desc'     : 'Informar o telefone celular de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRTELRESIFORCOBR' : {
  	        'desc'     : 'Informar o telefone fixo de cobrança do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },//ENTREGA
  	    'IDTPENDEFORNENTR' : {
  	        'desc'     : 'Informar o valor "T" para cadastrar o endereço de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDPAISENTR' : {
  	        'desc'     : 'Informar o pais de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'SGESTADOENTR' : {
  	        'desc'     : 'Informar o estado de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDMUNICIPIOENTR' : {
  	        'desc'     : 'Informar o código do município de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMMUNICIPIOENTR' : {
  	        'desc'     : 'Informar o nome do município de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSENDEFORNENTR' : {
  	        'desc'     : 'Informar o endereço de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSCOMPENDFORENTR' : {
  	        'desc'     : 'Informar o complemento do endereço de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMBAIRFORNENTR' : {
  	        'desc'     : 'Informar o bairro de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRCEPFORNENTR' : {
  	        'desc'     : 'Informar o CEP de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSEMAILFORNENTR' : {
  	        'desc'     : 'Informar o email de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'DSEMAILFORNNFEENTR' : {
  	        'desc'     : 'Informar o email XML NF-e de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRCELULARFORENTR' : {
  	        'desc'     : 'Informar o telefone celular de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRTELRESIFORENTR' : {
  	        'desc'     : 'Informar o telefone fixo de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    
  	    //Tabela Conta Contabil
  	    'CDCONTCTBL' : {
  	        'desc'     : 'Código da Conta Contábil até 20 dígitos.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDCONTREDU' : {
  	        'desc'     : 'Código da Conta reduzido até 20 dígitos.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMCONTCTBL' : {
  	        'desc'     : 'Nome.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDNVCONTCTBL' : {
  	        'desc'     : 'Nível da Conta.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDCONTANTE' : {
  	        'desc'     : 'Código da Conta Anterior.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'IDTIPOCONT' : {
  	        'desc'     : 'A - Analitico;\nS - Sintetico;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 2
  	        
  	    },
  	    'IDNATUCONT' : {
  	        'desc'     : 'Identificador Natureza Conta.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'IDPADRREL' : {
  	        'desc'     : 'Padrão de Relatório.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'IDGRUPOCONTA' : {
  	        'desc'     : 'Identificado de Grupo de Conta.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'IDCONTCCUS' : {
  	        'desc'     : 'O - Oficilal;\nR - Gerencial;\nG - Oficial/Gerencial;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 3
  	        
  	    },
  	    'CDCONTPLANREFE' : {
  	        'desc'     : 'Conta Referencial Lucro Real.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDCONTREFEPRE' : {
  	        'desc'     : 'Conta Referencial Lucro Presumido.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDCONTREFEIMUISEN' : {
  	        'desc'     : 'Informar o telefone fixo de entrega do fornecedor.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    
  	    //Tabela Centro Custo
  	    'CDCENTCUST' : {
  	        'desc'     : 'Código do Centro de Custo.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMCENTCUST' : {
  	        'desc'     : 'Nome do do Centro de Custo.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDFILIAL' : {
  	        'desc'     : 'Código da Filial.\nPassando como parâmetro apenas a letra T, indica para adicionar todas as filiais.\nPara adicionar as filiais manualmente basta digitar o seu código e separa-las por ;',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 3
  	        
  	    },
  	    
  	    //Tabela Tipo Recebimento
  	    'CDTIPORECE' : {
  	        'desc'     : 'Código do Tipo de Recebimento.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NMTIPORECE' : {
  	        'desc'     : 'Nome do Tipo de Recebimento.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'VRTAXAADMI' : {
  	        'desc'     : 'Valor da Taxa Administrativa.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'NRDIASADMI' : {
  	        'desc'     : 'Numero de dias para receber a Taxa Administrativa.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    },
  	    'CDTPCTRECEB' : {
  	        'desc'     : 'Código do Tipo de Conta do Recebimento.',
  	        'template' : 'field/textarea.html', 
  	        'textRows' : 1
  	        
  	    }
  	};*/
  	
  	/**
  	 * Essa parte diz respeito ao carregamento dos campos no grid.
  	 * Basicamente quando o campo de tabela é prenchido, é feito uma busca
  	 * retornando os campos da tabela e as configurações
  	 * e posteriormente criando colunas no grid de acordo com a quantidade de campos
  	 * e com o nome de cada campo retornado
  	 */
  	 
    function setDataSourceRoute(tableName) {
        let route;
        
        switch (tableName) {
            case 'MARCA':
                route = 'product#/crud/tab_column_marca';
            break;
        }
        
        return route;
    }
  	
    this.getFields = function() {
        const widget = templateManager.container.getWidget('tabbedWidget');
        const widgetErro = templateManager.container.getWidget('widgetErros');
        const widgetCampos = templateManager.container.getWidget('widgetCampos');
        const widgetInfos  = templateManager.container.getWidget('widgetInfos');
        let route;
        let table_name = widget.currentRow.NMTABELA;
        
        widgetErro.dataSource.data = [{'IDREF':0, 'DESCERROR':"Não há erros"}];
        
        route = setDataSourceRoute(table_name);
        
        const filter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "TABLE_NAME",
                "operator": "=",
                "value": table_name
            }
        ];
        
        General.callRestEngine(route, 'FilterData', filter).then(function(success) {
            widgetCampos.fields = [];
            widgetInfos.fields = [];
            //EXPORTA TODAS AS COLUNAS DO SELECT DO BANCO PARA A TELA
            switch(widget.currentRow.NMTABELA){
                case 'MARCA':
                    fields = success.dataset.tab_column_marca;
                break;
            }
            
            let data   = {};
            let tabela;
            switch(widget.currentRow.NMTABELA){
                case 'MARCA':
                    tabela = 'Marca';
                break;
            }
            
            //SELECIONA QUAIS COLUNAS IRÃO APARECER NA TELA
            fields = filtraCamposTabelas(table_name, fields);

            for(var i = 0; i < fields.length; i++){
                geraFields(fields[i], widgetCampos, false);
                geraFieldsInfo(fields[i], widgetInfos);
                
                campos[i] = fields[i].COLUMN_NAME;
                data[fields[i].COLUMN_NAME] = '';
            }
            
            widgetCampos.dataSource.data = [data];
            widgetCampos.label = tabela; //exibe nome da tabela
            
            const banco = "cadFis#/crud/".concat(widget.currentRow.NMTABELA.toLowerCase());
            widgetCampos.dataSource.name = banco;
            
            widgetCampos.activate();
            
            if(!widgetErro.isActive()){
                widgetCampos.redraw(true);
                widgetInfos.redraw(true);
            }
        });
    };

  	this.habilitaWidgetInfos = function (widget_name){
        const widget = templateManager.container.getWidget(widget_name);
        const widget_table = templateManager.container.getWidget('tabbedWidget');
        const table_name = widget_table.currentRow.NMTABELA;
        
        widget.isVisible = table_name != 'FORNECEDOR_ENDEFORN' && 
            table_name != 'CONTCTBL' && 
            table_name != 'CENTCUST_CENTCUSTFIL' && 
            table_name != 'TIPORECE';
    };
    
    function filtraCamposTabelas(table_name, dataset) {
        let objeto = [];
        for(let i = 0; i < dataset.length; i++){
            let column_name = dataset[i].COLUMN_NAME;
            if(colunas(objeto,column_name) < 1){
                objeto.push(fields[i]);
            }
        }
        
        return objeto;
    }
    
    function colunas(dataset, column_name) {
        //let numeroDeRepeticoes = 0;
        // for(var i = 0; i < dataset.length; i++){
        //     if(dataset[i].COLUMN_NAME == column_name)
        //         numeroDeRepeticoes++;
        // }
        
        //Otimizado
        return dataset.filter((data) => data.COLUMN_NAME == column_name).length;
    }        
    
    function geraFieldsInfo(field, widget) {
        geraFields(field, widget, true).then(function(){
            setaFields(field, widget);
        });
    }
    
    function geraFields (field, widget, info){
        var deferred = ZHPromise.defer();
        
        if (field.COLUMN_NAME == 'VRTAXAADMI') {
            if (!info) {
                field = {
                    "name": field.COLUMN_NAME,
                    "label": field.COLUMN_NAME,
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "readOnly": true,
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    },
                    "mask": {
                        "type": "float",
                        "params": {
                            "symbol": " ",
                            "precision": 2,
                            "thousands": ".",
                            "decimal": ",",
                            "operator": "="
                        }
                    },   
                };
            }else{
                field = {
                    "name": field.COLUMN_NAME,
                    "label": field.COLUMN_NAME,
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "readOnly": true,
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    },
                };
            }
        }else{
             field = {
                "name": field.COLUMN_NAME,
                "label": field.COLUMN_NAME,
                "template": "field/text-edit.html",
                "isVisible": true,
                "showOnList": true,
                "showOnForm": true,
                "showOnView": true,
                "readOnly": true,
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false
                },
            };
        }
        
        metaDataFactory.fieldFactory(field, widget, widget);
        
        deferred.resolve();
        return deferred.promise;
    }
    
    function setaFields (field, widget){
        var deferred = ZHPromise.defer();
        const nmtabela = templateManager.container.getWidget('tabbedWidget').currentRow.NMTABELA;
        const glossary = ServiceImportacao.getGlossary(nmtabela);
        
        if (glossary.hasOwnProperty(field.COLUMN_NAME))
            for (var data in glossary[field.COLUMN_NAME]) {
                if(data == 'desc')
                    widget.getField(field.COLUMN_NAME).setValue(glossary[field.COLUMN_NAME].desc);
               else
                    widget.getField(field.COLUMN_NAME)[data] = glossary[field.COLUMN_NAME][data];
            }
        
        deferred.resolve();
        return deferred.promise;
    }
    
    /**
     * Parte referente aos métodos de importação da planilha,
     * juntamente com a chamada das validações e carregamento
     * dos erros encontrados nos dados colocado na planilha
     */
    
    this.abreImportacao = function() {
        const widgetImportacao = templateManager.container.getWidget('importaXls');
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        
        if (tabbedWidget.isValid()) {
            widgetImportacao.currentRow = {};
            widgetImportacao.currentRow.__is_new = true;
            
            ScreenService.openPopup(widgetImportacao);
        }
    };
    
    this.importarXls = function(widget){
        if(widget.isValid()){
            const widgetCampos = templateManager.container.getWidget('widgetCampos');
            let errorMessage;
            let file = widget.currentRow.FILEXLS;
            const pos = file[0].b64File.indexOf(',') + 1;
            
            erros = [];
            
            file = {
                'name': file[0].name,
                'content': file[0].b64File.substr(pos)
            };
            
            const row = {
                'FILE': file,
                'CAMPOS': campos,
                'TABLE_NAME': widget.getParent().currentRow.NMTABELA
            };
            
            General.callRestEngine("product#/importXls", "Row", row).then(function(success) {
      	        widgetCampos.dataSource.data = success.dataset.import;
      	        widget.redraw();
      	        
      	        ScreenService.successNotification("Tabela importada");
      	        ScreenService.closePopup();
            }).catch(function(error) {
                if (error.error == 'XLS_READER_HEADER_SIZE_ERROR') {
                    errorMessage = 'Erro no cabeçalho das colunas do arquivo XLS.';
                    ScreenService.showMessage(errorMessage); 
                } else if (error.errorCode == 500) {
                    errorMessage = 'Tabela do arquivo XLS incorreta.';
                    ScreenService.showMessage(errorMessage); 
                }
            });
            
            ScreenService.closePopup();
        }   
    };
    
    function setFieldTabelaReadOnly(isReadOnly) {
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        
        tabbedWidget.getField('NMTABELA').readOnly = isReadOnly;
    }
    
    this.openErros = function (args) {
        const widget = args.owner;
        const row = widget.currentRow;
        const widgetErros = templateManager.container.getWidget('widgetErros');
        
        ScreenService.openSwipe(widgetErros);
        
        if (widget.currentRow.ERROS && widget.currentRow.ERROS.length > 0) {
            mostraErros(row);
            
            setFieldTabelaReadOnly(true);
        } else {
            widgetErros.dataSource.data = [{"COLUMN": "", "DESCERROR": 'Não há erros'}];
        }
    };
    
    this.backWidgetErros = function () {
        ScreenService.closeSwipe();
        
        setFieldTabelaReadOnly(false);
    };
    
    function mostraErros (row){
        const widgetErros = templateManager.container.getWidget('widgetErros');
        
        widgetErros.dataSource.data = row.ERROS;
    }
    
    this.saveImport = function(widget){
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        const widData = widget.dataSource.data;
        
        const data = [
            {
                "ROWS": widData,
                "TABLE_NAME": tabbedWidget.currentRow.NMTABELA
            }    
        ];
        
        if (widData.length) {
            General.callRestEngine("product#/saveImport", "DataSet", data);
        } 
    };
}


/* global Configuration */
Configuration(function (ContextRegister) {
	ContextRegister.register('Ger00000_Cadastramentos_Automatico_Controller', Ger00000_Cadastramentos_Automatico_Controller);
});

// FILE: ./assets/js/controllers/ger00003_unidadeController.js
var UnidadeController = function (ScreenService, UnidadeService, Parametros, eventAggregator) {

	this.onEnter = function (widget) {
		widget.reload();
	};

	this.afterMoveRow = function (unit) {
		var message = "Deseja confirmar a troca de unidade?";
		ScreenService.confirmMessage(message, "question", function() {
			changeUnit(unit);
		});
	};

	var changeUnit = function(unit) {
		UnidadeService.alterarEstrutura(unit.CDFILIAL, unit.NRORG).then(function() {
			UnidadeService.updateMongoSession(unit.NMFILIAL, unit.CDFILIAL).then(function() {
				updateLocalSession(unit);
				setLocalVar('OPENMODALAF', 'N');
			}, callbackError);
		}, callbackError);
	};

	var updateLocalSession = function(unit) {
		Parametros.retornaDataProcessamento(unit.CDFILIAL, unit.NRORG).then(function (dtprocessa) {
			unit.DTPROCESSA = dtprocessa;
			setLocalVars(unit);
			buildUserAndHeader();
			eventAggregator.publish("onUnitChange", unit);
			ScreenService.openWindow('product#dashboard');
		}, callbackError);
	};

	function buildUserAndHeader() {
		var nmoperador = getLocalVar('NMOPERADOR');
		var dtprocessa = getLocalVar('DTPROCESSA');
		var cdfilial = getLocalVar('CDFILIAL');
		var nmfilial = getLocalVar('NMFILIAL');
		var unidade = cdfilial + " - " + nmfilial;
		var headerInfo = dtprocessa + " | " + unidade;
		ScreenService.buildUserData(nmoperador, [dtprocessa, unidade], userMethod);
		ScreenService.setHeaderInfo(headerInfo);
	}

	function userMethod() {
		// @todo create user profile window
	}

	var setLocalVars = function (unidade) {
		setLocalVar("CDFILIAL", unidade.CDFILIAL);
		setLocalVar("NMFILIAL", unidade.NMFILIAL);
		setLocalVar("DTPROCESSA", unidade.DTPROCESSA);
	};

	var callbackError = function(err) {
		ScreenService.showMessage(JSON.stringify(err.data));
	};

};

Configuration(function (ContextRegister) {
	ContextRegister.register('UnidadeController', UnidadeController);
});

// FILE: ./assets/js/controllers/inicioController.js
var Inicio_Controller = function(templateManager, LibUtilities, ApplicationContext, localStorageEngine, requestDataSourceEngine, ScreenService, restEngine, metaDataFactory, General, utilitiesNext){
    var self = this;
    
    var modalConfirmaRecebimentoAF = function () {
		var widgetConfirmaRecebAF = metaDataFactory.widgetFactory({
		    "id": "0",
			"name": "recebimentoAF",
			"label": "Confirmação de Recebimento",
			"template": "widget/grid.html",
			"isVisible": true,
			"showCheckbox": true,
			"showAsModal": true,
			"floatingControl": {
                "csvAction": false,
                "pdfAction": false,
                "xlsAction": false,
                "refreshAction": false,
                "customizationAction": {
                    "filter": false,
                    "layout": false,
                    "view": false
                }
            },
			"dataSource": {
                "name": "product#/crud/confirmaRecebimentoAF",
                "rest": true,
                "lazyLoad": true
            },
            "dataSourceFilter": [
                {
                    "name": "P_CDFILDEST",
                    "value": "@getLocalVar('CDFILIAL')@",
                    "operator": "="
                },
                {
                    "name": "P_NRORG",
                    "value": "@getLocalVar('NRORG')@",
                    "operator": "="
                }
            ],
			"fields": [
			    {
                    "name": "NRAUTOFORN",
                    "label": "AF",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "NRINSJURFORN",
                    "label": "Inscrição",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "NMFANTFORN",
                    "label": "Nome Fantasia",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "DTPROGENTAF",
                    "label": "Dt Entrega AF",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "dateFormat": "DD/MM/YYYY",
                    "template": "field/calendar.html",
                    "events": [],
                    "disableOrdering": true
                },
                {
                    "name": "IDCONFRECEBIMENTO",
                    "label": "Recebimento",
                    "isVisible": true,
                    "readOnly": false,
                    "showOnForm": true,
                    "showOnView": false,
                    "showOnList": true,
                    "class": 3,
                    "template": "field/text-edit.html",
                    "events": [],
                    "disableOrdering": true
                }
			  ],
			"actions": [
				{
					"name": "salvar",
					"label": "Salvar",
					"isVisible": true,
					"hideIcon": true,
					"showAsAction": "never",
					"events": [
						{
							"name": "ActionEvent",
							"code": "Inicio_Controller.confirmarRecebimento(args.owner.widget)"
						}
					]
				},
				{
                    "name": "ENTREGATOTAL",
                    "label": "Entrega Total",
                    "isVisible": true,
                    "icon": "truck-checked",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
                    "name": "ENTREGAPARCIAL",
                    "label": "Entrega Parcial",
                    "isVisible": true,
                    "icon": "issue",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
                    "name": "NAOENTREGUE",
                    "label": "Não Entregue",
                    "isVisible": true,
                    "icon": "stock-error",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
				    "name": "DEVOLUCAO",
                    "label": "Devolução",
                    "isVisible": true,
                    "icon": "before",
                    "showAsAction": "checked_rows",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.alteraStatusAF(args.owner.widget, args.owner);"
                        }
                    ]
				},
				{
				    "name": "NOTHING",
                    "label": "",
                    "isVisible": true,
                    "hideIcon ": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Inicio_Controller.doNothing(args.owner);"
                        }
                    ]
				}
			],
			"events": []
		}, templateManager.container);
		widgetConfirmaRecebAF.reload().then(function(){
        	if(widgetConfirmaRecebAF.dataSource.data.length){
        	    ScreenService.openPopup(widgetConfirmaRecebAF);
        	    self.setVisibilityFooterModalPopUp('0', 'hidden');
        		widgetConfirmaRecebAF.activate();
        		ScreenService.showMessage('Para acessar o TecFood atualize o status de todas as AFs pendentes!');
                setLocalVar('OPENMODALAF', 'N');
        		let interval = setInterval(function () {
        		    if($('.zh-new-grid-recebimentoAF').parents('section.popup-container').find('.zh-footer-left').length){
            		    $('.zh-new-grid-recebimentoAF').parents('section.popup-container').find('.zh-footer-left').attr('style', 'visibility:hidden');
            		    clearInterval(interval);
        		    }
        		}, 500);
            }else{
                setLocalVar('OPENMODALAF', 'S');
                self.verifyDashboard();
            }
		});
	};
    
    this.openModalConfirmaRecebimento = function(){
        let params = {
            CDOPERADOR: getLocalVar('CDOPERADOR'),
            NRORG: getLocalVar('NRORG')
        };
        General.callRestEngine('product#/idAutPerfAcesso', 'Row', params).then(function(callback) {
            if(callback.dataset.data.IDAUTPERFACESSO){
                if(getLocalVar('CDFILIAL')){
                    if(!getLocalVar('OPENMODALAF') || getLocalVar('OPENMODALAF') === 'N'){
                        let row = [{
                            "CDFILIAL" : getLocalVar('CDFILIAL')
                        }];
                        General.callRestEngine('product#/verifyParamIdutlconfrecaf', 'Row', row).then(function(callback) {
                            if(callback.dataset && callback.dataset.data && callback.dataset.data.IDUTLCONFRECAF === 'S'){
                                modalConfirmaRecebimentoAF();
                            }else{
                                setLocalVar('OPENMODALAF', 'S');
                                self.verifyDashboard();
                            }
                	    });
                    }else{
                        self.verifyDashboard();
                    }
                }
            }else{
                self.verifyDashboard();
            }
        });
    };
    
    this.confirmarRecebimento = function(widget){
        let rowsUpdate = [];
        
        widget.dataSource.data.filter(function (rowUpdate){
            if(rowUpdate.changed){
                rowsUpdate.push(rowUpdate);
            }
        });
        if(rowsUpdate.length){
            General.callRestEngine('product#/updateStatusAF', 'Row', rowsUpdate).then(function(callback) {
                ScreenService.closePopup(widget);
                self.setVisibilityFooterModalPopUp('0', 'none');
                modalConfirmaRecebimentoAF();
    	    });
        }else{
            ScreenService.showMessage('Para acessar o TecFood atualize o status de todas as AFs pendentes!');
        }
    };
    
    this.alteraStatusAF = function(widget, action){
        let status;
        switch (action.name) {
            case 'ENTREGATOTAL':
                status = 'Entrega Total';
                break;
            case 'ENTREGAPARCIAL':
                status = 'Entrega Parcial';
                break;
            case 'NAOENTREGUE':
                status = 'Não Entregue';
                break;
            default:
                status = 'Devolução';
                break;
        }
        let backupRow;
        let index;
        let data = widget.dataSource.data;
        data.forEach(function (row){
            if(row.__isSelected){
                row.IDCONFRECEBIMENTO = status;
                row.changed = true;
                backupRow = row;
                index = data.indexOf(row);
                delete data[index];
                data.push(backupRow);
            }
        });
        
        widget.dataSource.clearCheckedRows();
        
    };
    
    this.verifyDashboard = function() {
        const frame = 'dashboardNextFrame';

        if (typeof templateManager.project.modulesInfo === "string" && templateManager.project.modulesInfo.split(', ').indexOf('dsb') === -1) {
            if (window.nextUrl) {
                getFrameWidgetNext(frame).sourceUrl = utilitiesNext.getUrlTecFoodNext('dsb/dashboardNext');
            } else {
                self.dashboardAngular(frame);
            }
        } else {
            getFrameWidgetNext(frame).sourceUrl = window.location.href+'Logo';
        }
    };
    
    var getFrameWidgetNext =  function(frame){
		return templateManager.container.getWidget(frame);
	};
    
    this.dashboardAngular = function(frame) {
        var filter = [{
            'name': 'P_CDFILIAL',
			'operator': '=',
			'value': "FILIAL_LOGADA"
        },{
            'name': 'P_CDOPERADOR',
			'operator': '=',
			'value': "OPERADOR_LOGADO"
        }];
        
        requestDataSourceEngine.getDataSource("dsb#/crud/hasAccess", filter).then(function(response){
            if (response.dataset.hasAccess.length && response.dataset.hasAccess[0].NRPAINEL) {
				localStorageEngine.setDataSource("dsb#/painelPadrao", response.dataset.hasAccess).then(function() {
					LibUtilities.openWindow("dsb#dashboard");
				}).catch(function (){
				    getFrameWidgetNext(frame).sourceUrl = window.location.href+'Logo';
				});
			} else {
                getFrameWidgetNext(frame).sourceUrl = window.location.href+'Logo';
			}
        });
    };
    
    this.setVisibilityFooterModalPopUp = function(idModal, visibility) {
        let interval = setInterval(function() {
            if($('#grid-' + idModal).length) {
                clearInterval(interval);
                $('#grid-' + idModal).parents('section.navbar-fixed-bottom').siblings('footer').find('div#footer').attr('style', 'visibility: ' + visibility);
            }            
        }, 500);
    };
    
};


Configuration(function(ContextRegister) {
       ContextRegister.register('Inicio_Controller', Inicio_Controller);
});

// FILE: ./assets/js/controllers/integracaoController.js
var IntegracaoController = function (templateManager, ZhPreferences, ZhFilterPreferences, MessageService) {

    let copyToClipboard = str => {
        const el = document.createElement('textarea');
        el.value = str;
        document.body.appendChild(el);
        el.select();
        document.execCommand('copy');
        document.body.removeChild(el);
    };

    function buildFilter(name, value) {
        return {
            "name": name,
            "operator": "=",
            "value": value
        };
    }

    function setNRLOGINTCARDAMESOnDataSourceFilter (widget, value){
        if(widget.dataSourceFilter.find(dsf=> dsf.name === 'NRLOGINTCARDAMES')){
            widget.dataSourceFilter.find(dsf=> dsf.name === 'NRLOGINTCARDAMES').value = value;
        }else{
            widget.dataSourceFilter.push(buildFilter('NRLOGINTCARDAMES', value));
        }
    }

    this.onTabEnter = function (widget){
        widget.reload();
    };

    this.openFilterOnStart = function () {
        let widget = templateManager.container.getWidget('log');
        ZhPreferences.getDefaultWidgetPreferences(widget.id).then(result => {
            ZhFilterPreferences.openFilterWidget(widget, {});
        });
    };

    this.setFiltredDates = function (args) {
        
        let widget = templateManager.container.getWidget('log');

        let dates = args.e.preference.FILTER_ROW.DATAFILTER;
        let start = moment(dates.start, 'YYYY-MM-DD').format('DD/MM/YYYY');
        let end = moment(dates.end, 'YYYY-MM-DD').format('DD/MM/YYYY');

        if(start == "Invalid date"|| end == "Invalid date"){
            start = null;
            end = null;
        }

        widget.dataSourceFilter.push(buildFilter('DTINICIO', start));
        widget.dataSourceFilter.push(buildFilter('DTFIM', end));

        widget.dataSourceFilter = widget.dataSourceFilter.filter(dsf =>
            dsf.name !== "DATAFILTER"
        );
        
        widget.reload();
    };

  

    this.setFilterForMod = function (){
        let widget = templateManager.container.getWidget('log');
        let NRLOGINTCARDAMES = widget.currentRow.NRLOGINTCARDAMES;
        let tabModWiget = widget.widgets.find(w=>w.name==='modified');
        let tabExCWiget = widget.widgets.find(w=>w.name==='excluded');
        let tabErrWiget = widget.widgets.find(w=>w.name==='errors');

        if(widget.currentRow.HASERRORS === 'S'){
            tabExCWiget.isVisible = false;
            tabErrWiget.isVisible = true;
        }else if (widget.currentRow.HASERRORS === 'N'){
            tabExCWiget.isVisible = true;
            tabErrWiget.isVisible = false;
        }

        setNRLOGINTCARDAMESOnDataSourceFilter(tabModWiget, NRLOGINTCARDAMES);
        setNRLOGINTCARDAMESOnDataSourceFilter(tabExCWiget,NRLOGINTCARDAMES);
        setNRLOGINTCARDAMESOnDataSourceFilter(tabErrWiget,NRLOGINTCARDAMES);
    };
    
};

Configuration(function (ContextRegister) {
    ContextRegister.register('IntegracaoController', IntegracaoController);
});

// FILE: ./assets/js/controllers/parametrizacaoAplicativos.js
var ParametrizacaoAplicativos = function (General, templateManager, parametrizacaoAplicativosService, ScreenService, MessageService, Colors, ZhKeyboardService) {
   //teste
   /*global QRCode, imagesField, getLocalVar, Configuration*/
    var self = this;
    const NAME_APPS_QRCODE = ["MYORDER", "APPROVE", "OPERATIONS", "MYQUEST"];
    var kbUp, kbDown;
    
    this.checkMaxApps = function () {
        let mainWidget = templateManager.container.getWidget('applist');
        parametrizacaoAplicativosService.checkMaxApps().then(resp => {
            mainWidget.getAction('ADD').isVisible = (resp.dataset.remaningApps.length > 0);
        });
    };

    this.editAppConfig = function () {
        let mainWidget = templateManager.container.getWidget('applist');
        General.edit(mainWidget);
        mainWidget.currentRow.__createdLocal = false;
        mainWidget.currentRow.__is_new = false;
    };

    this.add = function (widget) {
        templateManager.container.getWidget('applist').newRow();
        widget.getField("URLLOGO").noFileSelectedText = "";
    };

    this.remove = function () {
        let mainWidget = templateManager.container.getWidget('applist');
        MessageService.confirmMessageByCode("deleteQuestion").then(() => {
			parametrizacaoAplicativosService.deleteRow(mainWidget.currentRow).then(() => {
				ScreenService.closeSwipe().then(() => {
                    mainWidget.reload();
                    MessageService.notificationMessageByCode("successOnRemove", null, { type: "success" });
                });
			});
		});
    };

    this.save = function () {
        let mainWidget = templateManager.container.getWidget('applist');
        if (mainWidget.isValid()) {
            if(mainWidget.currentRow.DSCORPRIMARIA != "" && mainWidget.currentRow.DSCORPRIMARIA != null){
                mainWidget.currentRow.DSCORPRIMARIA = TransformColor(mainWidget.currentRow.DSCORPRIMARIA);
            }
            
            if(mainWidget.currentRow.URLLOGO === window.undefinedImage){
                mainWidget.currentRow.URLLOGO = null;
            }
            
            parametrizacaoAplicativosService.saveRow(mainWidget.currentRow).then((response) => {
                let rowSaved = response.dataset.rowSaved[0];
                MessageService.notificationMessageByCode("successOnSave", null, {type: "success"});
                mainWidget.currentRow = rowSaved;
                mainWidget.currentRow.__createdLocal = false;
                mainWidget.currentRow.__is_new = false;
                
                self.trataCor(mainWidget);
                mainWidget.view();
                
                ScreenService.closeSwipe().then( _ => {
                    mainWidget.reload();
                });
                this.generateQRCode(mainWidget);
            }).catch((response) => {
                ScreenService.showMessage(response.data.error);
            });
        }
    };

    this.checkFileExtension = function () {
        let mainWidget = templateManager.container.getWidget('applist');
        setTimeout(()=>{
            let logo = mainWidget.getField('URLLOGO').value();
            let extension = logo.length ? logo[0].name.split('.') : [""];
            
            extension = extension.pop();
            extension = extension.toUpperCase();
            
            if (extension > 0 && !(extension === 'jpg' || extension === 'jpeg')) {
                MessageService.showMessageByCode("imageInvalidFormat", null, {type: "error"});
                mainWidget.getField('URLLOGO').value(null);
            }
        },350);
    };
    
    this.generateQRCode = (widget) => {
        setTimeout(() => {
            let imgs = document.getElementsByTagName("img");
            let imagesField = document.getElementById("span-field-QRCODE");
            
            let idApp = widget.currentRow.IDAPLICATIVO;
            let showQrCode = NAME_APPS_QRCODE.findIndex( NAME => idApp === NAME) > -1;

            if(showQrCode && !imagesField){
                self.generateQRCode(widget);
                return;
            }
                        
            for (var i=0; i<imgs.length; i++) {
                if (imgs[i].alt == "qrCodeGenerated")
                    imagesField.removeChild(imgs[i]);
            }
            
            widget.getAction("downloadQRCode").isVisible = showQrCode;
            widget.getField("qrcodeLabel").isVisible = showQrCode;

            templateManager.updateTemplate().then( _ => {
                if(showQrCode){
                    let qrCodeURL = widget.currentRow.DSDNS + ";" + getLocalVar("NRORG");
                    new QRCode(imagesField.id, qrCodeURL);
                    
                    $("#span-field-QRCODE")[0].style.textAlign = "center";
                    $("#span-field-QRCODE")[0].style.marginTop = "20px";
                } 
            });
        }, 300);
    };
    
    this.trataCor = function(owner) {
        let currentRow = owner.currentRow;
         
        owner.dataSource.data.forEach(function(row) {
            if(row.DSCORPRIMARIA != null && row.__treated == undefined){
                    row.DSCORPRIMARIA = Colors.TColorToHex(row.DSCORPRIMARIA);
                    row.__treated = true;
            }        
        });
        if(currentRow.DSCORPRIMARIA != null && currentRow.__treated == undefined){
            currentRow.DSCORPRIMARIA = Colors.TColorToHex(currentRow.DSCORPRIMARIA);
            currentRow.__treated = true;
        }
    };

    function TransformColor(Color) {
        let r, g, b, h;
        if (Color.toString().charAt(0) != '#') {
            r = Color._r.toString();
            g = Color._g.toString();
            b = Color._b.toString();
            if (r.indexOf('.') != -1) {
                r = r.substr(0, r.indexOf('.'));
            }
            if (g.indexOf('.') != -1) {
                g = g.substr(0, g.indexOf('.'));
            }
            if (b.indexOf('.') != -1) {
                b = b.substr(0, b.indexOf('.'));
            }
            r = parseInt(r);
            g = parseInt(g);
            b = parseInt(b);
        }
        else {
            h = Color.substring(1, 7);
            r = parseInt((h).substring(0, 2), 16);
            g = parseInt((h).substring(2, 4), 16);
            b = parseInt((h).substring(4, 6), 16);
        }

        return r | (g << 8) | (b << 16);
    }
    
    this.setCor = function(row, fieldName, element) {
        if (row[fieldName]) {
            if (typeof row[fieldName] === "number") {
                row[fieldName] = Colors.TColorToHex(row[fieldName]);
            }
            else if (typeof row[fieldName] === "object") {
                row[fieldName] = Colors.TColorToHex(TransformColor(row[fieldName]));
            }
            setTimeout(function() {
                var column = element.find('.td:eq(3)');
                if(column.context.className.indexOf('td') !== -1){
                    var styles = column.context.getAttribute('style') || "";
                    
                    styles = styles.split(';');
                    styles = styles.filter(s => !s.includes('background'));
                    styles.push('background: '+row[fieldName] + ' !important');
                    styles = styles.join(';');
                    column.context.setAttribute('style', styles);
                    column.context.textContent = '';
                }                
            }, 100);
        }
    };
    
    this.download = function() {
        var link = document.createElement("a");
        link.download = "QrCode";
        link.href = getLocalVar("qrcode_uri");
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
    };
    
    this.cancel = function(args){
        General.backOrCancel(args);
        self.generateQRCode(args.owner.widget);
    };
    
    this.moveRow = function(widget){
        self.generateQRCode(widget);
        
        if(widget.updateSwipeTip){
            widget.updateSwipeTip(widget.currentRow);
        }
        
        if(!widget.currentRow.URLLOGO){
            widget.currentRow.URLLOGO = window.undefinedImage;
        }
    };
    
    this.unbindKeyboardEvents = function() {
        if (kbUp){
            ZhKeyboardService.unbind(kbUp);    
        }             
        if (kbDown){
            ZhKeyboardService.unbind(kbDown);     
        }          
    };
    
    this.bindKeyboardEvents = function() {
        kbUp = ZhKeyboardService.bind("up", validateViewWidget);
        kbDown = ZhKeyboardService.bind("down", validateViewWidget);
    };
    
    function validateViewWidget() {
        var mainWidget = templateManager.container.getWidget("applist");
        if(mainWidget.inViewMode()) {
            self.generateQRCode(mainWidget);
        }
    }
    
};


Configuration(function (ContextRegister) {
    ContextRegister.register('ParametrizacaoAplicativos', ParametrizacaoAplicativos);
});


